#define CLINE_MAX_SIZE 2000
#define CLINE_MAX_TOKENS 1000

#define CLINE_UNKNOWN        0
#define CLINE_FUNCTION       1
#define CLINE_DECL_LOCAL     3
#define CLINE_DECL_GLOBAL    4
#define CLINE_BRACE_LEFT     5
#define CLINE_BRACE_RIGHT    6
#define CLINE_DIRECTIVE      7
#define CLINE_STATEMENT      8
#define CLINE_CONTROL        9
#define CLINE_PROTOTYPE     10
#define CLINE_LOOP          11
#define CLINE_TYPEDEF       12
#define CLINE_STRUCT        13
#define CLINE_TYPE_STRUCT   14
#define CLINE_STRUCT_TYPE   15
#define CLINE_STRUCT_VAR    16
#define CLINE_STRUCT_ELEM   17
#define CLINE_DECL_STRUCT   18
#define CLINE_SWITCH        21
#define CLINE_CASE          22
#define CLINE_SKIP          23
#define CLINE_COMMENT       32
#define CLINE_C_COMMENT     33
#define CLINE_C_COMMENTS    34

#define CSTATE_IDLE        0
#define CSTATE_STRUCT      1
#define CSTATE_TYPE_STRUCT 2
#define CSTATE_FUNCTION    3
#define CSTATE_C_COMMENTS  4

void initcline(void);
LinkT *getcline(int *pclinetype, int *pnewline);
void SetEndPtr(LinkT *list);
LinkT *GetEndPtr(int offset);
void checkcline(LinkT *tokenlist, int clinetype);
void PrintFileLine(void);
int UpdateAndGetIndentLevel(int clinetype, int *oneliner);
