#define CVARS_MAX_NUM 1000

#define CVARS_LOCAL     0
#define CVARS_GLOBAL    1
#define CVARS_FUNCTION  2
#define CVARS_PARM      3
#define CVARS_STRUCT    4
#define CVARS_PROTOTYPE 5

typedef struct TypeInfoS {
    struct TypeInfoS *next;
    char *str;
    int ptrlevel;
    int signflag;
    int floatflag;
    int size;
    int value;
    int funcptr;
    int numparms;
    struct TypeInfoS *typedefptr;
    LinkT *structvars;
} TypeInfoT;

typedef struct VarInfoS {
    struct VarInfoS *next;
    char *str;
    char *str1;
    int ptrlevel;
    int signflag;
    int use;
    int numdims;
    int dimsize[10];
    int value;
    int funcptr;
    int numparms;
    struct TypeInfoS *typeinfo;
} VarInfoT;

int SearchVariableList(char *str);
int getcvars(LinkT *tokenlist, int clinetype);
void PrintVariableList(FILE *outfile);
void PurgeLocalParms(void);
void seperateinits(LinkT **ptokenlistin, LinkT **ptokenlistdefer);
char *ReturnVariableType(int i);
char *ReturnVariableUse(int i);
void ProcessTypedef(char **tokens, int num);
int GetUseLink(VarInfoT *varlink);
int GetArrayLink(VarInfoT *varlink);
int GetVarSizeLink(VarInfoT *varlink, int indirect);
TypeInfoT *AddToTypesList(char *typename, int typesize, int signflag);
void PrintTypes(void);
TypeInfoT *FindType(TypeInfoT *typeinfo, char *str);
VarInfoT *FindVariable(VarInfoT *varinfo, char *varname);
void AddIntrinsicFunction(char *type, char *cvar, char *svar);
int SizeOfVarInfo(VarInfoT *varinfo);
void AddFuncProtoToVarList(char *type, int ptrlevel, char *name, int numparms);
void AddCFuncProtoToVarList(char *type, int ptrlevel, char *name, int numparms);
VarInfoT *AddObjFuncProtoToVarList(char *name);
